//
//  FTPLister.h
//  FTPUploadPlugin
//
//  Created by Sebastian Krauß on 20.06.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "FTPUploadPlugin.h"

#import "Defines.h"



//#define FTPListDebug 1


#define kMyBufferSize  32768

typedef struct MyStreamInfo {
    
    CFWriteStreamRef  writeStream;
    CFReadStreamRef   readStream;
    CFDictionaryRef   proxyDict;
    SInt64            fileSize;
    UInt32            totalBytesWritten;
    UInt32            leftOverByteCount;
    UInt8             buffer[kMyBufferSize];
    
} MyStreamInfo;



@interface FTPLister : NSObject {
    //static id delegate;
    //NSMutableArray *subDirectories;
}

- (id)initWithAddress:(NSString*)addr user:(NSString*)uname password:(NSString*)pw delegate:(id)del;
- (void)cancelListing;
/*- (void)setupStreamInfo:(MyStreamInfo **) info readStream:(CFReadStreamRef)readStream writeStream:(CFWriteStreamRef) writeStream;
- (void)cleanupStreamInfo:(MyStreamInfo *) info;*/
    static void
    MyDirectoryListingCallBack(CFReadStreamRef readStream, CFStreamEventType type, void * clientCallBackInfo);
    static void
    MySetupStreamInfo(MyStreamInfo ** info, CFReadStreamRef readStream, CFWriteStreamRef writeStream);
    static void
    MyCleanupStreamInfo(MyStreamInfo * info);
    static void
    MyPrintDirectoryListing(CFDictionaryRef dictionary);



@end
